'' myQS_HIBset.spin

CON
  _clkmode = XTAL1 + PLL16X
  _clkfreq = 80_000_000

'' VGA ''''''''''''
CON
  columns  = driver#res_x / 9
  rows    = driver#res_y / font#height
  bcnt    = columns * rows
  
  rows_raw = (driver#res_y + font#height - 1) / font#height
  bcnt_raw = columns * rows_raw
CON
  vgrp  = 2
  mode  = 1
  video = (vgrp << 9 | mode << 8 | %%333_0) << 21
CON
  CURSOR_ON      = driver#CURSOR_ON
  CURSOR_OFF     = driver#CURSOR_OFF
  CURSOR_ULINE   = driver#CURSOR_ULINE
  CURSOR_BLOCK   = driver#CURSOR_BLOCK
  CURSOR_FLASH   = driver#CURSOR_FLASH
  CURSOR_SOLID   = driver#CURSOR_SOLID
  
  #0, CM, CX, CY
'''''''''''''''''''  
  
OBJ
  misc   :  "tools"
  driver :  "waitvid.80x25.driver.2048"
  font   :  "halfrange8x16-2font"
  
  
  
VAR
'' VGA '''''''''
  long scrn[bcnt_raw / 2]
  long link[driver#res_m]
  long cursor
''''''''''''''''
   
PUB Start
  vga_banner
  main

PUB main
  repeat
  
PUB vga_banner
  link{0} := video | @scrn{0}
  link[1] := font#height << 24 | font.addr
  link[2] := @cursor * $00010001
  
  driver.init(-1, @link{0})
  
  misc.waitms(50)
  setCursor(CURSOR_ON|CURSOR_ULINE|CURSOR_FLASH)

'' Print string text, non-flashing BG, use %1110_100_1 flash BG  
  printText(%1110_100_0, string("This is the QS_HIBset program"))
  misc.waitms(50)
  
PRI setCursor(setup)
  cursor.byte{CM} := (cursor.byte{CM} & !(CURSOR_ON|CURSOR_ULINE|CURSOR_FLASH)) | setup

PRI printText(attr, s)
  repeat strsize(s)
    printChar(attr, byte[s++])
    
PRI printChar(attr, c) | x, y
  c &= 127
  
  x := cursor.byte[CX]
  y := cursor.byte[CY]
  
  attr.byte[1] := c
  scrn.word[bcnt_raw - y * columns - ++x] := attr
  ifnot x //= columns
    y := ++y // rows
    
  cursor.byte[CX] := x
  cursor.byte[CY] := y